#pragma once
#include <fstream>
#include <sstream>
#include <iostream>

namespace DXFW
{
/// <summary>t@C̓Ǎ[h</summary>
enum class FileMode
{
	Read,///Ǎ̂
	Write,///̂
	Add,///Aɒǉ
	None,///JĂȂ
};

/// <summary></summary>
///	<example>
///	[TvR[h:]<BR>
/// Tv<BR>
///	<code>
///	int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,LPSTR lpCmdLine, int nCmdShow )<BR>
///	{<BR>
///		if( !Dx::Initialise() ) return -1;<BR>
///		Dx::End();<BR>
///		return 0;<BR>
/// }<BR>
/// </code>	
/// </example>
class File
{
private:
	std::ifstream fst;
	bool canRead;
	bool canWrite;
	bool canAdd;
	bool isBinary;
	std::string fileName;

public:
	
	///<summary>t@CJ</summary>
	///t@Cƃ[hw肵āAeLXgt@CoCit@CJB
	File(const char* t@C , FileMode ǂݏ[h , bool oCit@C = false )
	{
		File::Open( t@C , ǂݏ[h , oCit@C );
	}
	
	///<summary>t@CJ</summary>
	///RXgN^Ɠ
	bool Open(const char* t@C , FileMode ǂݏ[h , bool oCit@C = false )
	{
		std::string mode;
		this->fileName = t@C;

		switch(ǂݏ[h)
		{
			case FileMode::Read:
				if( isBinary )	fst.open( t@C , std::ios::in | std::ios::binary );
				else			fst.open( t@C , std::ios::in );
				canRead = true;
				canWrite = false;
				canAdd = false;
			break;
			case FileMode::Write:
				if( isBinary )	fst.open( t@C , std::ios::out | std::ios::binary );
				else			fst.open( t@C , std::ios::out );
				canWrite = true;
				canRead = false;
				canAdd = false;
			break;
			case FileMode::Add:
				if( isBinary )	fst.open( t@C , std::ios::out | std::ios::app | std::ios::binary );
				else			fst.open( t@C , std::ios::out | std::ios::app );
				canWrite = true;
				canAdd = true;
				canRead = false;
			break;
		}

		this->isBinary = oCit@C;

		if ( fst.fail() )
		{
			canRead = false;
			canWrite = false;
			canAdd = false;
		}

		return true;
	}

	///<summary>JgfBNg̐ݒ</summary>
	///st@C̑΃pXŃJgfBNgݒ肷
	static void SetDirectory( const char* fBNg )
	{			
		char full [MAX_PATH+1];
		char drive[MAX_PATH+1];
		char dir  [MAX_PATH+1];
		char fname[MAX_PATH+1];
		char ext  [MAX_PATH+1];			

		GetModuleFileName( NULL , full , MAX_PATH );

		_splitpath_s( full ,
						drive , sizeof(drive),
						dir ,sizeof(dir),
						fname ,sizeof(fname),
						ext , sizeof(ext)); 

		std::string path = drive;
		path += dir;
		path += fBNg;

		SetCurrentDirectory( path.c_str() );
	}

	///<summary>t@C</summary>
	bool Close()
	{
		fst.close();
		canRead = false;
		canWrite = false;
		canAdd = false;
	}
			
	/// <summary>t@C[h擾</summary>
	FileMode GetFileMode()
	{
		if( this->canAdd )  return FileMode::Add;
		if( this->canWrite) return FileMode::Write;
		if( this->canRead ) return FileMode::Read;
		return FileMode::None;
	}

	///<summary>t@C擾</summary>
	const char* GetFileName()
	{				
		return this->fileName.c_str();
	}

	///<summary>f[^ǂݍ</summary>
	///FileMode::Read̏ꍇB
	///ǍϐɃf[^ǂݍށB
	template< class T>
	bool Read(T &Ǎϐ )
	{
		if( canRead ) fst << Ǎϐ;
		return canRead;
	}
			
	///<summary>f[^</summary>
	///FileModeWriteAdd̏ꍇB
	///ϐt@CɏށB
	template< class T>
	bool Write(T &ϐ)
	{
		if( canWrite ) fst >> ϐ;
		return canWrite;
	}
			
	///<summary>f[^̓ǂݏ</summary>
	///FileModeRead̏ꍇǍAWriteAdd̏ꍇsB
	template< class T>
	bool ReadWrite(T &buf )
	{
		if( canRead )
		{
			fst >> buf;
			return true;
		}else if( canWrite ){
			fst << buf;
			return true;
		}		
		return false;
	}
	
	///<summary>t@CsǍ</summary>
	///FileModeRead̏ꍇB
	///t@CsǍAɑ
	bool GetLine(std::string &str)
	{
		if( canRead ) getline( fst , str );
		return canRead;
	}
			
	///<summary>CSVt@C̈sǍ</summary>
	///FileModeRead̏ꍇB
	///t@CsǍAJ}؂ňɑ
	bool GetLineCSV(std::vector<std::string> &strSet)
	{
		if( canRead )
		{
			std::string str;
			std::string buf;

			getline( fst , str );
			std::istringstream iss( str );

			while( getline( iss , buf , ',' ) )
			{
				strSet.push_back( buf );
			}
		}
		return canRead;
	}
	
	///<summary>t@C̏I[</summary>
	///t@CI[ɒBtrueԂ
	bool CheckEOF()
	{
		return ( fst.eof() );
	}

};
}