#pragma once
#include "DXFrameWork.h"

namespace DXFW
{
/// <summary></summary>
enum class Belong
{
	Ally,
	EnemyF,
	EnemyG,
	Item,
	Block,
	Etc
};

/// <summary></summary>
class Object : public Model
{
friend class Layer;

protected:
	/// <summary></summary>
	virtual bool RemoveCheck(Rect* area)
	{
		if(
			timer == this->lifeTime ||
			(isOutCheck && !figure->Hit( area ) )
			)
		{
			this->isRemove = true;
		}

		if (isRemove) Remove();

		return this->isRemove;
	}

	virtual void Attack(Object *hit )
	{
		hit->Damaged( power , attribute);
	}

public:
	bool isRemove;
	bool isOutCheck;
	double  power;
	int  attribute;
	int  timer;
	int  lifeTime;
	const Belong belong;

	Object( Figure *figure , Sprite *sprite , double power = 0 , Belong belong = Belong::Etc):
		Model( figure , sprite ),
		isOutCheck(true),
		isRemove(false),
		timer(0),
		lifeTime(-1),
		power(power),
		belong(belong)
	{}

	virtual ~Object(){}

	virtual void Update()
	{
		this->timer++;
		AnimeUpdate();
		this->Act();
	}

	int  GetTimer()
	{
		return this->timer;
	}
	void SetTimer(int timer)
	{
		this->timer = timer;
	}

	bool GetRemoveFlag()
	{
		return isRemove;
	}

	/// <summary></summary>
	virtual void Act()
	{

	}

	/// <summary></summary>
	virtual void Remove()
	{

	}

	/// <summary></summary>
	virtual void React()
	{

	}

	/// <summary></summary>
	virtual void Damaged(double damage, int attribute)
	{
		
	}

	/// <summary></summary>
	void Oi(double x)
	{
		MovePolar(x, GetAngle());
	}

	void i(double x , double px)
	{
		MovePolar(x, px);
	}

	void ˕Ԃ(double x, double &px, Rect &ړ͈)
	{
		const double PAI = 3.1415926535897931;

		//͈͊Oɂ
		if ( GetX() < ړ͈.GetLeft())
		{
			if (px > PAI / 2 && px < PAI * 3 / 2)
			{
				px = -PAI - px;
			}
		}

		if ( GetX() > ړ͈.GetRight())
		{
			if (px < PAI / 2 || px > PAI * 3 / 2)
			{
				px = PAI - px;
			}
		}
		else if (GetY() < ړ͈.GetTop())
		{
			if (px > PAI)
			{
				px = PAI * 2 - px;
			}
		}
		else if (GetY() > ړ͈.GetBottom())
		{
			if (px < PAI)
			{
				px = -px;
			}
		}

		if (px < 0) px += PAI * 2;
		if (px > PAI * 2) px -= PAI * 2;

		MovePolar(x, px);
	}

	bool wړ(double x, double ڕWX, double ڕWY)
	{
		const double lx = ڕWX - GetX();
		const double ly = ڕWY - GetY();

		if (lx * lx + ly * ly <= x * x )
		{
			SetPos(ڕWX, ڕWY);
			return true;
		}
		else{
			const double angle = atan2(ly, lx);
			MovePolar(x, angle);
			return false;
		}		
	}

	struct ~O
	{
		~O( double p ):
			px(p)
		{}

		double px;
		double OʒuX;
		double OʒuY;		
		bool   tO = false;
	};

	void ~O(double px , ~O &, double aX, double aY)
	{
		if ( !.tO )
		{
			.OʒuX = cos(.px) * aX;
			.OʒuY = sin(.px) * aY;
		}

		.px += px;

		const double nextX = cos(.px) * aX;
		const double nextY = sin(.px) * aY;

		Move(nextX - .OʒuX, nextY - .OʒuY);

		.OʒuX = nextX;
		.OʒuY = nextY;
	}

	struct U
	{
		double ړX = 0;
		double ړY = 0;
	};
	void U(U & , double XU , double YU)
	{
		.ړX = Rand::Get(-XU, XU) - .ړX;
		.ړY = Rand::Get(-YU, YU) - .ړY;
		Move( .ړX , .ړY );
	}

};
}