#pragma once
#include"DxLib.h"
#include"Image.h"

namespace DXFW
{
/// <summary>⊮̕@</summary>
enum class DrawMode
{
	Nearest = DX_DRAWMODE_NEAREST,
	Bilinear = DX_DRAWMODE_BILINEAR
};
	
/// <summary>uh[h</summary>
enum class BlendMode
{
	NoBlend = DX_BLENDMODE_NOBLEND,
	Alpha = DX_BLENDMODE_ALPHA,
	Add = DX_BLENDMODE_ADD,
	Sub = DX_BLENDMODE_SUB,
	Mula = DX_BLENDMODE_MULA,
	Invsrc = DX_BLENDMODE_INVSRC
};

/// <summary></summary>
///	<example>
///	[TvR[h:]<BR>
/// Tv<BR>
///	<code>
///	int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,LPSTR lpCmdLine, int nCmdShow )<BR>
///	{<BR>
///		if( !Dx::Initialise() ) return -1;<BR>
///		Dx::End();<BR>
///		return 0;<BR>
/// }<BR>
/// </code>	
/// </example>
class Screen
{
private:
	Screen();
	~Screen();
	static int& Handle()
	{
		static int handle = -1;
		return handle;
	}
public:
	///<summary>`͈͂w</summary>
	///w肵͈͊Oɂ͕`悳Ȃ
	static bool SetArea(int x1,int y1,int x2,int y2)
	{
		return !DxLib::SetDrawArea( x1 , y1 , x2 , y2 );
	}
	

	///<summary></summary>
	///static bool SetValidMultiSample( int samples, int quality )
	///{
	///	return !DxLib::SetDrawValidMultiSample( samples , quality );
	///}
	
	///<summary></summary>
	///static bool SetValidFloatTypeGraphCreateFlag(bool isFloat)
	///{
	///	return! DxLib::SetDrawValidFloatTypeGraphCreateFlag( isFloat );
	///}
	
	///<summary>쐬摜̃rbg[xݒ</summary>
	///摜ǂݍގ̃rbg[xƁA掿
	///gp郁܂
	///̊֐́AImage::Loadŉ摜ǂݍޑOɌĂԕKv
	static bool SetCreateGraphColorBitDepth(int bitDepth)
	{
		return !DxLib::SetCreateGraphColorBitDepth( bitDepth );
	}
	
	///<summary>XN[pImagẽ`lݒ</summary>
	///`l1,2,4̂ꂩw
	///XN[pImagew肵`lō쐬悤ɂȂ
	///Image::Make֐ĂԑOɁÅ֐ĂԕKv
	static bool SetCreateValidGraphChannelNum(int channelNum)
	{
		return !DxLib::SetCreateDrawValidGraphChannelNum( channelNum );
	}
	
	///<summary>`̐ݒ</summary>
	///Image::Draw̕`𗠉ʂɂB
	///SetImagegpĂ߂Ɏg
	static bool SetBack()
	{
		return !DxLib::SetDrawScreen( DX_SCREEN_BACK  );
	}
	
	///<summary>`C[Wݒ</summary>
	///XN[pMakeImage`ɐݒ肷B
	///`eScreen::FlipŔfB
	static bool SetImage(Image &img)
	{
		if( img.GetIsScreen() )
		{
			Handle() = img.GetHandle();
			return !DxLib::SetDrawScreen( img.GetHandle()  );
		}else{
			return false;
		}
	}
	
	///<summary>Screen::Clear̐Fݒ</summary>
	static bool SetBackColor(int r,int g,int b)
	{
		return !DxLib::SetBackgroundColor( r , g , b );
	}
	
	///<summary>`e𔽉f</summary>
	///
	static bool Flip()
	{
		return !DxLib::ScreenFlip();
	}
	
	///<summary>ʂ̓eA\ʂɃRs[</summary>
	static bool Copy()
	{
		return !DxLib::ScreenCopy();
	}
	
	///<summary>ʂ</summary>
	///̐FSetBackColorŐݒ肷
	static bool Clear()
	{
		return !DxLib::ClearDrawScreen();
	}
	
	///<summary>g`̕⊮@ݒ</summary>
	static bool SetMode(DrawMode mode)
	{
		return !DxLib::SetDrawMode( (int)mode );
	}
	
	///<summary>uh`̃[hݒ</summary>
	static bool SetBlendMode(BlendMode blendMode,int pal)
	{
		return !DxLib::SetDrawBlendMode( (int)blendMode , pal );
	}
	
	/// <summary>`ΏۂɂȂĂʂBMP`ŕۑ</summary>
	static bool SaveBmp(int x1, int y1 , int x2 , int y2 , const char *t@C )
	{
		return !DxLib::SaveDrawScreen( x1 ,  y1 , x2 , y2 , t@C );
	}

	///<summary>`Pxݒ</summary>
	static bool SetBright( int r , int g , int b )
	{
		return !DxLib::SetDrawBright( r , g , b );
	}

	///<summary>ߐFݒ</summary>
	static bool SetTransColor( int r , int g , int b )
	{
		return !DxLib::SetTransColor( r , g , b );
	}
	
	///<summary>Zobt@gptOݒ</summary>
	static void SetZUse(bool gptO )
	{
		DxLib::SetUseZBufferFlag( gptO );
	}
		
	///<summary>Zobt@`tOݒ</summary>
	static void SetZWrite(bool gptO )
	{
		DxLib::SetWriteZBufferFlag( gptO );
	}

	///<summary>Z`[xݒ</summary>
	///Z[x0.0`1.0
	static void SetZDepth(double Z[x)
	{
		DxLib::SetDrawZ( (float)Z[x );
	}
};
}