#pragma once
#include<DxLib.h>
#include<string>
#define NULL_HANDLE -1

namespace DXFW
{
///	<summary>̍Đ</summary>
enum class PlayType
{
	Normal = DX_PLAYTYPE_NORMAL,/// ĐȀ~߂
	Back = DX_PLAYTYPE_BACK,/// ĐȀ~߂Ȃ
	Loop = DX_PLAYTYPE_LOOP,/// ̏~߂Aŏ
};

///	<summary>NX</summary>
///	<example>
///	[TvR[h:]<BR>
/// ǂ݂ōĐ<BR>
///	<code>
///	int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,LPSTR lpCmdLine, int nCmdShow )<BR>
///	{<BR>
///		if( !Dx::Initialise() ) return -1;<BR>
///		Dx::End();<BR>
///		return 0;<BR>
/// }<BR>
/// </code>		
/// </example>
class Sound
{
private:
	int handle;
public:		
	Sound():
		handle( NULL_HANDLE)
	{}

	///<summary>t@Cɓǂݍ</summary>
	Sound(const char *fileName)
	{
		this->handle = DxLib::LoadSoundMem(fileName);
	}
		
	///<summary>t@Cɓǂݍ</summary>
	int Load(const char *fileName)
	{
		if(this->handle != NULL_HANDLE ) DxLib::DeleteSoundMem(handle);
		return this->handle = DxLib::LoadSoundMem(fileName);
	}
	
	///<summary>t@CJ</summary>
	bool Release()
	{
		return !DxLib::DeleteSoundMem(handle);
	}

	///<summary>nh擾</summary>
	int GetHandle() const
	{
		return this->handle;
	}
		
	///<summary>t@CĐ</summary>
	bool Play(PlayType playType = PlayType::Back , bool isTopPosition = true) const
	{
		return !DxLib::PlaySoundMem(this->handle , (int)playType , isTopPosition);
	}
		
	///<summary>Đ</summary>
	bool Check() const
	{
		return !DxLib::CheckSoundMem(this->handle);
	}
		
	/// <summary>Đ~</summary>
	bool Stop()
	{
		return !DxLib::StopSoundMem(this->handle);
	}
		
	/// <summary>pݒ</summary>
	bool SetPan(int panPal)
	{
		return !DxLib::SetPanSoundMem(panPal,this->handle);
	}
		
	/// <summary>ʂݒ</summary>
	bool SetVolume(double volumePal)
	{
		return !DxLib::ChangeVolumeSoundMem( int(volumePal*255),this->handle);
	}
		
	/// <summary>Đgݒ</summary>
	///Pʂ̓wc100`100,000
	bool SetFrequency(int frequencyPal)
	{
		return !DxLib::SetFrequencySoundMem(frequencyPal,this->handle);
	}
		
	///<summary>[vʒuݒ</summary>
	///~bPʂŃ[vʒuݒ
	bool SetLoopPos(int loopTime)
	{
		return !DxLib::SetLoopPosSoundMem( loopTime , this->handle );
	}
		
	///<summary>[vʒuݒ(TvOg)</summary>
	///TvOgŃ[vʒuwB
	///44.1KHz̏ꍇA44,100n1b̈ʒuŃ[v
	bool SetLoopSamplePos(int loopSamplePosition)
	{
		return !DxLib::SetLoopSamplePosSoundMem( loopSamplePosition , this->handle );
	}
};
}