
#pragma once
#include <DxLib.h>

namespace DXFW
{
///	<summary>ԂƓt̃NX</summary>
///	<example>
///	[TvR[h:]<br></br>
/// Tv
///	<code>
///	int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,LPSTR lpCmdLine, int nCmdShow )<br></br>
///	{<br></br>
///		if( !Dx::Initialise() ) return -1;<br></br>
///		Dx::End();<br></br>
///		return 0;<br></br>
/// }<br></br>
/// </code>
/// </example>
class Time
{
private:
	int count;
	double hiCount;
	DATEDATA date;		
	double prevTime;
	double fps;
	double start;

	Time(void)
	{
		this->ResetCount();
	}
	~Time(void){};

	static Time& Single()
	{
		static Time value;
		return value;
	}

public:
	
	///<summary>Ԃ̏</summary>
	static bool ResetCount()
	{
		Single().count   = DxLib::GetNowCount();
		Single().hiCount = double(DxLib::GetNowHiPerformanceCount())/1000;
		return true;
	}
	
	///<summary>ZbǧoߎԂ~bŎ擾</summary>
	static int GetNowCount()
	{
		return DxLib::GetNowCount() - Single().count;
	}
	
	///<summary>ZbǧoߎԂ̃~bŎ擾(_ȉ)</summary>
	static double GetDoubleCount()
	{
		return double(DxLib::GetNowHiPerformanceCount())/1000 - Single().hiCount;
	}

	///<summary>t擾</summary>
	static DATEDATA GetDate()
	{
		DxLib::GetDateTime( &Single().date );
		return Single().date;
	}
	
	///<summary>FPS擾</summary>
	static double GetFPS()
	{
		return Single().fps;
	}
	
	///<summary>FPŠvJn</summary>
	static void ResetFPS()
	{
		Single().prevTime = double(GetNowHiPerformanceCount()/1000);
	}
	
	///<summary>FPSvXV</summary>
	static void CheckFPS()
	{
		Single().fps = 1000000.0 / ( GetNowHiPerformanceCount() - Single().prevTime*1000 );
		Single().prevTime = double(GetNowHiPerformanceCount())/1000;
	}
	
	///<summary>ԌvJn</summary>
	static void StartWatch()
	{
		Single().start = double(GetNowHiPerformanceCount())/1000;
	}
	
	///<summary>ԌvI</summary>
	///StartWatcȟoߎԂ~bPʂŕ`
	///DrawWatch鎖\
	static void DrawWatch(int x , int y , const char* str)
	{
		std::string buf = str;
		buf += " = %f";

		Drawing::String( x , y , Color::White , buf.c_str() , (double)(GetNowHiPerformanceCount() - Single().start*1000) / 1000 );
		Single().start = 0;
	}
};

}